%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This work is licensed under a Creative Commons Attribution 4.0
% International License. http://creativecommons.org/licenses/by/4.0/
% The authors do not assume liability for errors contained in or for
% damages arising from the use of the software.
%
% CC-BY (4.0) Oliver Taubmann (oliver.taubmann@fau.de), 2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [xs, ys] = segment_edge()
% Manually segment edge in current figure

disp('Left click to add new point to segmentation, right click to undo, any other button/key to finish');

xs = [];
ys = [];
hs = [];

while (true)
    [x, y, button] = ginput(1);
    
    if (button == 1) % left button
        xs = [xs x];
        ys = [ys y];
        if (length(xs) > 1)
            h = plot(xs(end-1:end), ys(end-1:end), 'r', 'LineWidth', 0.75);
        else
            h = plot(x, y, 'r');
        end
        hs = [hs h];
    elseif (button == 3) % right button
        if (isempty(xs))
            continue;
        end
        xs = xs(1:end-1);
        ys = ys(1:end-1);
        delete(hs(end));
        hs = hs(1:end-1);
    else
        break;
    end
end

end